﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace SecurityApp.CAPs.Model
{
    public class Company : INotifyPropertyChanged
    {
        #region Properties
        public string company_id
        {
            get { return m_company_id; }
            set
            {
                if (value != m_company_id)
                {
                    m_company_id = value;
                    OnPropertyChanged("company_id");
                }
            }
        }

        public string company_name
        {
            get { return m_company_name; }
            set
            {
                if (value != m_company_name)
                {
                    m_company_name = value;
                    OnPropertyChanged("company_name");
                }
            }
        }

        private SiteCollection sites;

        public SiteCollection Sites
        {
            get
            {
                if (sites == null)
                    sites = new SiteCollection();
                return sites;
            }
        }
        
        public bool IsSelected { get; set; }
        #endregion

        #region Constructor
        public Company(string company_id, string company_name)
        {
            m_company_id = company_id;
            m_company_name = company_name;
            IsSelected = false;
        }

        public Company() { }
        #endregion

        #region Fields
        //-- Output 3: This result set will consist of all sites, sorted by company_name and site_name, associated with one or more contract holder identified in Output2, with specific sites associated with the current CAP from cap_entity_xref where cap_id = @cap_id.
        private string m_company_id;    //-- company_id		char(25)		entity_id of the parent company of the site.
        private string m_company_name;  //-- company_name	varchar(60)		Description of the company from entity.md_description.
        #endregion

        #region INotifyPropertyChanged Members
        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string propertyName)
        {
            PropertyChangedEventHandler handler = PropertyChanged;

            if (handler != null)
            {
                handler(this, new PropertyChangedEventArgs(propertyName));
            }
        }
        #endregion
    }
}
